<template>
<st-content heading="Tutores">
  <st-register
      :key="componentKey"
      v-model="dialog"
      @refresh="refresh"
    />
  <div class="content-body">
    <div class="table-heading">
        <st-search
          text="Buscar por nombre de código"
          @enter="searchTutor($event)"
        />
        <st-primary-btn
          nombre="Registrar Tutor"
          @click="open"
        />
    </div>
    <st-data-table
      :dataInfo = "{ headers,items }"
      :dataPath = "path"
      :loading = "loading"
    />
  </div>
</st-content>
</template>

<script>
import DataTable from '@/components/DataTable'
import Search from '@/components/Search'
import Register from '@/components/tutor/RegisterTutor'

export default {
  components:{
    'st-data-table': DataTable,
    'st-search': Search,
    'st-register': Register
  },
  mounted(){
    this.searchTutor('')
  },
  data () {
    return{
      componentKey: 0,
      items: [],
      dialog:false,
      loading:false,
      path:{
        url: '/coordinador/tutor/',
        id: 'id_tutor' //rip camelcase
      },
      headers: [
      {
        text: 'Nombre',
        align: 'start',
        value: 'nombres',
      },
      {
        text: 'Código',
        value: 'codigo'
      }
      ],
    }
  },
  methods:{
    open(){
      this.dialog = true
      this.componentKey += 1; //forceRerender
    },
    async searchTutor(value){
          this.loading = true
          try{
            const idUnit = this.$store.state.role.idUnit;
            let { data: { data:items }} = await this.$api.getTutors(idUnit, value)
            this.items = items
          } catch(e){
            this.$store.commit('setError', e)
          }
          this.loading = false
    },
    refresh(response) {
      this.dialog=false
      this.searchTutor('')
    }
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
